#ifndef __FAD_BITS_H
#define __FAD_BITS_H
#include <cairo.h>
#include "fad.types.h"

void bits_init(bits_t* bits);
void bits_finish(bits_t* bits);

void bits_buffer(bits_t* bits, u8_t* buffer);
void bits_dump(bits_t* bits, u16_t num_line, FILE* fp);
u8_t* bits_tell(bits_t* bits);
void  bits_sync(bits_t* bits);

u8_t bits_get_u8(bits_t* bits);
u16_t bits_get_u16(bits_t* bits);
u32_t bits_get_u32(bits_t* bits);

s8_t bits_get_s8(bits_t* bits);
s16_t bits_get_s16(bits_t* bits);
s32_t bits_get_s32(bits_t* bits);

sbit_t bits_get_sbits(bits_t* bits, u32_t nbits);
ubit_t bits_get_ubits(bits_t* bits, u32_t nbits);
fbit_t bits_get_fbits(bits_t* bits, u32_t nbits);

s8_t bits_seek_nbits(bits_t* bits, u32_t nbits);

s8_t bits_seek_nbytes(bits_t* bits, u32_t nbytes);

void bits_get_rect(bits_t* bits, rect_t* rt);

void bits_get_matrix(bits_t* bits, cairo_matrix_t* mx);

void bits_get_rgbxform(bits_t* bits, rgbxform_t* cx);

void bits_get_rgbaxform(bits_t* bits, rgbaxform_t* cx);

#endif
